using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace erettsegi06_SMSszavak
{
    class erettsegi06_SMSszavak
    {
        struct szavakskdok
        {
            public StringBuilder sz;
            public StringBuilder kd;
        }
        
        static void Main()
        {

            #region 1.feladat: Bet kdols                      
            Console.WriteLine("1. Feladat: Kdoland bet:");
            string betuKod = "22233344455566677778889999";  
            char c = char.Parse(Console.ReadLine().ToLower());
            Console.WriteLine("Kdja: {0}", betuKod[c-97]); //97->'a' karakter
            #endregion

            #region 2.feladat: Sz kdolsa
            Console.WriteLine("\n2. Feladat: Kdoland sz:");
            string ksz = Console.ReadLine().ToLower();
            for (int i = 0; i < ksz.Length; ++i) 
                Console.Write("{0}", betuKod[ksz[i] - 97]);
            Console.WriteLine();
            #endregion

            #region 3.feladat: Szavak.txt beolvassa
            Console.WriteLine("\n3. Feladat: Szavak.txt beolvassa");
            List<szavakskdok> szavak = new List<szavakskdok>();
            using (StreamReader sr = new StreamReader("szavak.txt"))
            {
                while (!sr.EndOfStream)
                {
                    szavakskdok j = new szavakskdok()
                    {
                        sz = new StringBuilder(sr.ReadLine()),
                        kd = new StringBuilder(""),
                    };
                    szavak.Add(j);
                }
            }
            #endregion

            #region 4. feladat: Lehosszabb trolt sz
            Console.WriteLine("\n4. Feladat: A leghosszabb trolt sz:");
            string maxsz = (from sz in szavak
                             orderby sz.sz.Length descending
                             select sz.sz.ToString()).First();

            Console.WriteLine("Leghosszabb sz: {0} Hossza: {1}",
                    maxsz, maxsz.Length);
            #endregion

            #region 5. feladat: Rvid szavak szma
            Console.WriteLine("\n5. Feladat: Rvid szavak szma: {0}",
                              szavak.Count(sz => sz.sz.Length < 6));
            #endregion

            #region 6. kodok.txt kirsa
            Console.WriteLine("\n6. Feladat: Kodok.txt file kirsa:");
            using (StreamWriter sw = new StreamWriter("kodok.txt"))
            {
                foreach (szavakskdok s in szavak)
                {
                    StringBuilder kd = new StringBuilder();
                    for (int i = 0; i < s.sz.Length; ++i) 
                           kd.Append(betuKod[s.sz[i] - 97]);
                    sw.WriteLine(kd.ToString());
                    s.kd.Append(kd.ToString());
                }
            }
            #endregion

            #region 7. feladat: Szmsorhoz tartoz szavak
            Console.WriteLine("\n7. Feladat: Szmsorhoz tartoz szavak:");
            Console.Write("Krem a szmsort: ");
            string szmsor = Console.ReadLine();
            var lista = from sz in szavak
                        where sz.kd.ToString()==szmsor
                        select sz.sz.ToString();

            foreach (var i in lista) Console.WriteLine(i);
            #endregion

            #region 8. feladat: Melyik kdhoz tartozik tbb sz?
            Console.WriteLine("\n8. Feladat: Melyik kdhoz tartozik tbb sz?");
            var tbbkd = from sz in szavak
                          group sz by sz.kd.ToString() into g
                          where g.Count() > 1
                          orderby g.Count() descending //9. feladathoz, a 8.-hoz nem kell rendezni
                          select g;

            foreach (var i in tbbkd)
                foreach (var j in i) Console.Write("{0} : {1} ", j.kd, j.sz);
            #endregion

            #region 9. feladat: Melyik kdnak megfelel szbl van a legtbb?
            Console.WriteLine("\n\n9. Feladat: Melyik kdnak megfelel szbl van a legtbb?");
            Console.WriteLine("A kd, melyhez a legtbb sz tarozik:{0}",tbbkd.First().Key);
            Console.WriteLine("A kdhoz tartz szavak:");
            foreach (var i in tbbkd.First()) Console.WriteLine(i.sz);
            #endregion

            Console.ReadKey();

        }
    }
}
